<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <title>User List</title>
</head>

<body>
    <div class="container jumbotron">
        <div class="row form-group">
            <div class="col-sm-12 text-center">
                <h3><span class="border-bottom text-success"><b>USER LIST</b></span></h3>
            </div>
        </div>
        <div class="row form-group d-flex justify-content-center">
            <div class="col-sm-8">
                <div class="row bg-light p-3 rounded">
                    <div class="col-sm-2">
                        <label class="col-form-label"><b>Name</b></label>
                    </div>
                    <div class="col-sm-6">
                        <input id="inp-filter" class="form-control" placeholder="Filter by Name (Case sensitive)">
                    </div>
                    <div class="col-sm-4">
                        <button id="btn-filter" class="btn btn-success w-100">Filter User</button>
                    </div>
                </div>
            </div>
        </div>
        <div class="row form-group">
            <div class="col-sm-12">
                <table id="table-user" class="table table-sm table-light table-bordered table-striped table-hover">
                    <thead>
                        <tr>
                            <th>STT</th>
                            <th>Name</th>
                            <th>Username</th>
                            <th>Email</th>
                            <th>Address</th>
                            <th>Zip Code</th>
                            <th>Phone</th>
                            <th>Company</th>
                            <th>Action</th>
                        </tr>
                    </thead>
                    <tbody>

                    </tbody>
                </table>
            </div>
        </div>
    </div>
</body>

<script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gBASE_URL = "https://jsonplaceholder.typicode.com/users/";
    var gUserList = [];

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    // gán sự kiện load trang
    $(document).ready(onPageLoading);
    // hiệu chỉnh căn giữa cho table head
    $("thead th").addClass("text-center align-middle");
    // gán sự kiện click button Detail
    $("#table-user").on("click", ".btn-detail", onBtnDetailClick);
    // gán sự kiện click button Filter
    $("#btn-filter").click(onBtnFilterClick);
    
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    // function xử lý sự kiện load trang/F5
    function onPageLoading() {
        // B3: Gọi API lấy danh sách user
        let vAjaxrequest = apiGetUserList();
        vAjaxrequest.done(function(vResponse) {
            // B4: Xử lý hiển thị
            console.log("API Get User List Response Object:");
            console.log(vResponse);
            gUserList = vResponse;
            console.log("gUserList:");
            console.log(gUserList);
            loadUserListToTable(vResponse);
        })
    }

    // function xử lý sự kiện click button Detail
    function onBtnDetailClick() {
        console.log("%cBUTTON DETAIL - CLICK", "color: green");
        let vUserId = $(this).data("user-id");
        let vUrl = "userDetail.html?id=" + vUserId;
        window.location.href = vUrl;
    }

    // function xử lý sự kiện click button Filter
    function onBtnFilterClick() {
        console.log("%cBUTTON FILTER - CLICK", "color: green");
        // B1: thu thập dữ liệu
        let vNameFilter = $("#inp-filter").val().trim();
        // B2: Kiểm tra dữ liệu
        let vDataValid = checkFilterName(vNameFilter);
        if (vDataValid) {
            // B3: Xử lý hiển thị
            let vFilterResult = findName(vNameFilter);
            loadUserListToTable(vFilterResult);
        }
    }

    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    // function gọi API lấy danh sách user
    function apiGetUserList() {
        let vAjaxrequest = $.ajax({
            url: gBASE_URL,
            type: "GET"
        });
        return vAjaxrequest;
    }

    // function load user list vào table
    function loadUserListToTable(paramUserList) {
        $("#table-user tbody").html("");
        for (let bIndex = 0; bIndex < paramUserList.length; bIndex ++) {
            let bUser = paramUserList[bIndex];
            let bAddress = bUser.address.suite + " " + bUser.address.street + " " + bUser.address.city;
            // thêm dòng mới vào tbody
            let bNewRow = $("<tr>").appendTo($("#table-user tbody"));
            // thêm data tương ứng vào dòng mới
            bNewRow.append(
                $("<td>").html(bIndex + 1),             // cell STT
                $("<td>").html(bUser.name),             // cell Name
                $("<td>").html(bUser.username),         // cell Username
                $("<td>").html(bUser.email),            // cell Email
                $("<td>").html(bAddress),               // cell Address
                $("<td>").html(bUser.address.zipcode),  // cell Zip code
                $("<td>").html(bUser.phone),            // cell Phone number
                $("<td>").html(bUser.company.name),     // cell Company
                // thêm và xử lý button Chi Tiết
                $("<td>").append(
                    $("<button>")
                        .html("Detail")
                        .addClass("btn btn-success btn-detail")
                        .data("user-id", bUser.id)
                )
            );
        }
        // hiệu chỉnh align middle cho table data
        $("tbody td").addClass("align-middle");
    }

    // function kiểm tra dữ liệu filter name
    function checkFilterName(paramString) {
        if (paramString === "") {
            alert("Please enter name to start filter data");
            return false;
        }
        return true;
    }

    // function tìm kiếm tên
    function findName(paramString) {
        let vResult = [];
        for (let bUser of gUserList) {
            if (bUser.name.includes(paramString)) {
                vResult.push(bUser);
            }
        }             
        return vResult;
    }

</script>

</html>